"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const async_enumerable_1 = require("@reactive-js/async-enumerable");
const observable_1 = require("@reactive-js/observable");
const option_1 = require("@reactive-js/option");
const pipe_1 = require("@reactive-js/pipe");
const event_1 = require("./event");
const locationEquals = (a, b) => a === b ||
    (a.pathname === b.pathname && a.search === b.search && a.hash === b.hash);
const getCurrentLocation = (_) => {
    const pathname = window.location.pathname;
    const search = window.location.search;
    const hash = window.location.hash;
    return { pathname, search, hash };
};
const pushHistoryState = (newLocation) => {
    const currentLocation = getCurrentLocation();
    if (!locationEquals(currentLocation, newLocation)) {
        const { pathname, search, hash } = newLocation;
        let uriString = pathname;
        uriString = search.length > 0 ? `${uriString}${search}` : uriString;
        uriString = hash.length > 0 ? `${uriString}${hash}` : uriString;
        window.history.pushState(option_1.none, "", uriString);
    }
};
const historyOperator = (obs) => observable_1.merge(observable_1.compute(getCurrentLocation), pipe_1.pipe(obs, observable_1.throttle(15), observable_1.onNotify(pushHistoryState)), event_1.fromEvent(window, "popstate", getCurrentLocation));
const _history = async_enumerable_1.createAsyncEnumerable(historyOperator);
exports.history = _history;
//# sourceMappingURL=history.js.map